libzypp: zypp::ZYpp Class Reference

libzypp 17.25.10

Public Types | Public Member Functions | Private Types | Private Member Functions | Private Attributes | Friends | List of all members
zypp::ZYpp Class Reference

`#include <ZYpp.h>`

Inheritance diagram for zypp::ZYpp:
[legend]

## Public Types
typedef ::boost::shared_ptr< ZYpp > | Ptr
typedef ::boost::shared_ptr< const ZYpp > | constPtr
typedef ZYppCommitResult | CommitResult

## Public Member Functions
ResPool | pool () const
| Access to the global resolvable pool. More...
ResPoolProxy | poolProxy () const
| Pool of ui::Selectable. More...
DiskUsageCounter::MountPointSet | diskUsage ()
void | setPartitions (const DiskUsageCounter::MountPointSet &mp)
DiskUsageCounter::MountPointSet | getPartitions () const
Target_Ptr | target () const
Target_Ptr | getTarget () const
| Same as target but returns NULL if target is not initialized, instead of throwing. More...
void | initializeTarget (const Pathname &root, bool doRebuild_r=false)
void | finishTarget ()
ZYppCommitResult | commit (const ZYppCommitPolicy &policy_r)
| Commit changes and transactions. More...
void | installSrcPackage (const SrcPackage_constPtr &srcPackage_r)
| Install a source package on the Target. More...
ManagedFile | provideSrcPackage (const SrcPackage_constPtr &srcPackage_r)
| Provides a source package on the Target. More...
Resolver_Ptr | resolver () const
KeyRing_Ptr | keyRing () const
Pathname | homePath () const
| Get the path where zypp related plugins store persistent data and caches More...
Pathname | tmpPath () const
| Get the path where zypp related plugins store temp data More...
void | setHomePath (const Pathname &path)
| set the home, if you need to change it More...

## Private Types
typedef zypp_detail::ZYppImpl | Impl
typedef shared_ptr< Impl > | Impl_Ptr

## Private Member Functions
| ZYpp (const Impl_Ptr &impl_r)
| Factory ctor. More...
friend | void ::boost::checked_delete (ZYpp *)
| Deleted via shared_ptr. More...
| ~ZYpp ()
| Dtor. More...

## Private Attributes
RW_pointer< Impl > | _pimpl
| Pointer to implementation. More...

## Friends
class | ZYppFactory
| Factory. More...
std::ostream & | operator<< (std::ostream &str, const ZYpp &obj)

## Detailed Description

Todo:
  define Exceptions ZYpp API main interface

Definition at line 54 of file ZYpp.h.

## Member Typedef Documentation

## ◆ Ptr

typedef ::boost::shared_ptr<ZYpp> zypp::ZYpp::Ptr

Definition at line 60 of file ZYpp.h.

## ◆ constPtr

typedef ::boost::shared_ptr<const ZYpp> zypp::ZYpp::constPtr

Definition at line 61 of file ZYpp.h.

## ◆ CommitResult

typedef ZYppCommitResult zypp::ZYpp::CommitResult

Definition at line 109 of file ZYpp.h.

## ◆ Impl

typedef zypp_detail::ZYppImpl zypp::ZYpp::Impl
| private

Definition at line 146 of file ZYpp.h.

## ◆ Impl_Ptr

typedef shared_ptr<Impl> zypp::ZYpp::Impl_Ptr
| private

Definition at line 147 of file ZYpp.h.

## Constructor & Destructor Documentation

## ◆ ZYpp()

zypp::ZYpp::ZYpp | ( | const Impl_Ptr & | impl_r | ) |
| explicitprivate

Factory ctor.

Definition at line 307 of file ZYppFactory.cc.

## ◆ ~ZYpp()

zypp::ZYpp::~ZYpp | ( |  | ) |
| private

Dtor.

Definition at line 314 of file ZYppFactory.cc.

## Member Function Documentation

## ◆ pool()

ResPool zypp::ZYpp::pool | ( |  | ) | const

Access to the global resolvable pool.

Same as zypp::ResPool::instance

Definition at line 38 of file ZYpp.cc.

## ◆ poolProxy()

ResPoolProxy zypp::ZYpp::poolProxy | ( |  | ) | const

Pool of ui::Selectable.

Based on the ResPool, ui::Selectable groups ResObjetcs of same kind and name.

Definition at line 50 of file ZYpp.cc.

## ◆ diskUsage()

DiskUsageCounter::MountPointSet zypp::ZYpp::diskUsage | ( |  | ) |

Definition at line 41 of file ZYpp.cc.

## ◆ setPartitions()

void zypp::ZYpp::setPartitions | ( | const DiskUsageCounter::MountPointSet & | mp | ) |

Definition at line 44 of file ZYpp.cc.

## ◆ getPartitions()

DiskUsageCounter::MountPointSet zypp::ZYpp::getPartitions | ( |  | ) | const

Definition at line 47 of file ZYpp.cc.

## ◆ target()

Target_Ptr zypp::ZYpp::target | ( |  | ) | const

Exceptions

  Exception |

Definition at line 65 of file ZYpp.cc.

## ◆ getTarget()

Target_Ptr zypp::ZYpp::getTarget | ( |  | ) | const

Same as target but returns NULL if target is not initialized, instead of throwing.

Definition at line 68 of file ZYpp.cc.

## ◆ initializeTarget()

void zypp::ZYpp::initializeTarget | ( | const Pathname & | root,
|  | bool | doRebuild_r = `false`
| ) |  |

Exceptions

  Exception | Just init the target, dont populate store or pool. If `doRebuild_r` is `true`, an already existing database is rebuilt (rpm –rebuilddb ).

Definition at line 71 of file ZYpp.cc.

## ◆ finishTarget()

void zypp::ZYpp::finishTarget | ( |  | ) |

Exceptions

  Exception |

Definition at line 74 of file ZYpp.cc.

## ◆ commit()

ZYppCommitResult zypp::ZYpp::commit | ( | const ZYppCommitPolicy & | policy_r | ) |

Commit changes and transactions.

Parameters

ref CommitPolicy

Returns
  CommitResult

Exceptions

  Exception |

Definition at line 77 of file ZYpp.cc.

## ◆ installSrcPackage()

void zypp::ZYpp::installSrcPackage | ( | const SrcPackage_constPtr & | srcPackage_r | ) |

Install a source package on the Target.

Exceptions

  Exception |

Definition at line 80 of file ZYpp.cc.

## ◆ provideSrcPackage()

ManagedFile zypp::ZYpp::provideSrcPackage | ( | const SrcPackage_constPtr & | srcPackage_r | ) |

Provides a source package on the Target.

Exceptions

  Exception |

Definition at line 83 of file ZYpp.cc.

## ◆ resolver()

Resolver_Ptr zypp::ZYpp::resolver | ( |  | ) | const

Definition at line 53 of file ZYpp.cc.

## ◆ keyRing()

KeyRing_Ptr zypp::ZYpp::keyRing | ( |  | ) | const

Definition at line 56 of file ZYpp.cc.

## ◆ homePath()

Pathname zypp::ZYpp::homePath | ( |  | ) | const

Get the path where zypp related plugins store persistent data and caches

Definition at line 87 of file ZYpp.cc.

## ◆ tmpPath()

Pathname zypp::ZYpp::tmpPath | ( |  | ) | const

Get the path where zypp related plugins store temp data

Definition at line 90 of file ZYpp.cc.

## ◆ setHomePath()

void zypp::ZYpp::setHomePath | ( | const Pathname & | path | ) |

set the home, if you need to change it

Definition at line 93 of file ZYpp.cc.

## ◆ void ::boost::checked_delete()

zypp::ZYpp::void ::boost::checked_delete | ( | ZYpp * |  | ) |
| private

Deleted via shared_ptr.

## Friends And Related Function Documentation

## ◆ ZYppFactory

friend class ZYppFactory
| friend

Factory.

Definition at line 145 of file ZYpp.h.

## ◆ operator<<

std::ostream& operator<< | ( | std::ostream & | str,
|  | const ZYpp & | obj
| ) |  |
| friend

Definition at line 29 of file ZYpp.cc.

## Member Data Documentation

## ◆ _pimpl

RW_pointer<Impl> zypp::ZYpp::_pimpl
| private

Pointer to implementation.

Definition at line 157 of file ZYpp.h.

The documentation for this class was generated from the following files:

- zypp/ZYpp.h
- zypp/ZYpp.cc
- zypp/ZYppFactory.cc